Index: tools/rosdep/src/rosdep/freebsd.py
===================================================================
--- tools/rosdep/src/rosdep/freebsd.py	(revision 12349)
+++ tools/rosdep/src/rosdep/freebsd.py	(working copy)
@@ -31,7 +31,7 @@
 
 import os
 import roslib.os_detect
-import base_rosdep
+from . import base_rosdep
 
 ###### FreeBSD SPECIALIZATION #########################
 def port_detect(p):
@@ -63,7 +63,7 @@
             return "#No Packages to install"
         if default_yes:
             import sys
-            print >> sys.stderr, "pkg_add does not have a default_yes option, continuing without"
+            sys.stderr.write("pkg_add does not have a default_yes option, continuing without\n")
         return "#Packages\nsudo /usr/sbin/pkg_add -r " + ' '.join(packages)
 
 ###### END FreeBSD SPECIALIZATION ########################
Index: tools/rosdep/src/rosdep/gentoo.py
===================================================================
--- tools/rosdep/src/rosdep/gentoo.py	(revision 12349)
+++ tools/rosdep/src/rosdep/gentoo.py	(working copy)
@@ -26,7 +26,7 @@
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
-from __future__ import with_statement
+
 import os.path
 import roslib.os_detect
 import subprocess
@@ -67,6 +67,6 @@
         elif equery_available():
             return "#Packages\nsudo emerge " + ' '.join(packages)
         else:
-	    return "#Packages\nsudo emerge -u " + ' '.join(packages)
+            return "#Packages\nsudo emerge -u " + ' '.join(packages)
 
 ###### END Gentoo SPECIALIZATION ########################
Index: tools/rosdep/src/rosdep/arch.py
===================================================================
--- tools/rosdep/src/rosdep/arch.py	(revision 12349)
+++ tools/rosdep/src/rosdep/arch.py	(working copy)
@@ -28,8 +28,8 @@
 
 # Author Tully Foote/tfoote@willowgarage.com
 
-from __future__ import with_statement
-from linux_helpers import *
+
+from .linux_helpers import *
 import os
 
 import rosdep.base_rosdep
@@ -58,7 +58,7 @@
                 if os_list[0] == "Linux" and os_list[1] == "Arch":
                     return os_list[2]
         except:
-            print "Arch failed to get version"
+            print("Arch failed to get version")
             return False
 
         return False
Index: tools/rosdep/src/rosdep/cygwin.py
===================================================================
--- tools/rosdep/src/rosdep/cygwin.py	(revision 12349)
+++ tools/rosdep/src/rosdep/cygwin.py	(working copy)
@@ -51,6 +51,6 @@
 ###### END Cygwin SPECIALIZATION ########################
 
 if __name__ == '__main__':
-    print "cygwin installed?", Cygwin().check_presence()
-    print "test port_detect(true)", port_detect('cygwin');
-    print "version", Cygwin().get_version()
+    print("cygwin installed?", Cygwin().check_presence())
+    print("test port_detect(true)", port_detect('cygwin'));
+    print("version", Cygwin().get_version())
Index: tools/rosdep/src/rosdep/main.py
===================================================================
--- tools/rosdep/src/rosdep/main.py	(revision 12349)
+++ tools/rosdep/src/rosdep/main.py	(working copy)
@@ -108,9 +108,9 @@
             rdargs = roslib.packages.list_pkgs()
         
         (verified_packages, rejected_packages) = roslib.stacks.expand_to_packages(rdargs)
-    
+        
         if len(rejected_packages) > 0:
-            print "Warning: could not identify %s as a package"%rejected_packages
+            print("Warning: could not identify %s as a package"%rejected_packages)
         if len(verified_packages) == 0:
             parser.error("No Valid Packages listed")
                 
@@ -121,60 +121,60 @@
     ### Find all dependencies
     try:
         r = core.Rosdep(verified_packages, robust=options.robust)
-    except roslib.os_detect.OSDetectException, ex:
-        print "rosdep ABORTING.  Failed to detect OS: %s"%ex
+    except roslib.os_detect.OSDetectException as ex:
+        print("rosdep ABORTING.  Failed to detect OS: %s"%ex)
         return 1
 
-    except roslib.exceptions.ROSLibException, ex:
-        print "rosdep ABORTING: %s"%ex
+    except roslib.exceptions.ROSLibException as ex:
+        print("rosdep ABORTING: %s"%ex)
         return 1
 
     if options.verbose:
-        print "Detected OS: " + r.osi.get_name()
-        print "Detected Version: " + r.osi.get_version()
+        print("Detected OS: " + r.osi.get_name())
+        print("Detected Version: " + r.osi.get_version())
 
     try:
         if command == "generate_bash" or command == "satisfy":
-            print r.generate_script(include_duplicates=options.include_duplicates, default_yes=options.default_yes)
+            print(r.generate_script(include_duplicates=options.include_duplicates, default_yes=options.default_yes))
             return 0
         elif command == "install":
             error = r.install(options.include_duplicates, options.default_yes)
             if error:
-                print >> sys.stderr, "rosdep install ERROR:\n%s"%error
+                sys.stderr.write("rosdep install ERROR:\n%s"%error)
                 return 1
             else:
                 return 0
-    except core.RosdepException, e:
-        print >> sys.stderr, "ERROR: %s"%e
+    except core.RosdepException as e:
+        sys.stderr.write("ERROR: %s"%e)
         return 1
 
     try:
         if command == "depdb":
-            print r.depdb(verified_packages)
+            print(r.depdb(verified_packages))
             return 0
 
         elif command == "what_needs":
-            print '\n'.join(r.what_needs(rdargs))
+            print('\n'.join(r.what_needs(rdargs)))
             return 0
 
         elif command == "where_defined":
-            print r.where_defined(rdargs)
+            print(r.where_defined(rdargs))
             return 0
 
         elif command == "check":
             return_val = 0
             (output, scripts) = r.check()
             if len(rejected_packages) > 0:
-                print >> sys.stderr, "Arguments %s are not packages"%rejected_packages
+                sys.stderr.write("Arguments %s are not packages"%rejected_packages)
                 return_val = 1
             if len(output) != 0:
-                print >> sys.stderr, output
+                sys.stderr.write(output + "\n")
                 return 1
             if len(scripts)>0:
-                print >> sys.stderr, scripts
+                sys.stderr.write(scripts + "\n")
                 # not an error condition
 
             return return_val
-    except core.RosdepException, e:
-        print >> sys.stderr, str(e)
+    except core.RosdepException as e:
+        sys.stderr.write(str(e) + "\n")
         return 1
Index: bin/rosmake
===================================================================
--- bin/rosmake	(revision 12349)
+++ bin/rosmake	(working copy)
@@ -29,8 +29,8 @@
 
 
 # Author Tully Foote/tfoote@willowgarage.com
-from __future__ import with_statement
 
+
 import os
 import sys
 import subprocess
@@ -43,11 +43,11 @@
     #cmd = ["make", "-C", os.path.join(os.environ["ROS_ROOT"], "tools/rospack")] Doesn't work with cmake 2.6, will trigger rebuilds due to different paths.  Fixed in 2.8.
     cmd = ["bash", "-c", "cd %s && make"%(os.path.join(os.environ["ROS_ROOT"], "tools/rospack"))]
     if subprocess.call(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE) :
-        print "Rospack failed to build" 
+        print("Rospack failed to build") 
         return False
 
     if subprocess.call(["which", "rospack"], stdout=subprocess.PIPE, stderr=subprocess.PIPE):
-        print "Rospack not in path.  Please add ROS_ROOT/bin to PATH"
+        print("Rospack not in path.  Please add ROS_ROOT/bin to PATH")
         return False
     return True
     
@@ -71,6 +71,6 @@
 for t in threading.enumerate():
     if t != threading.currentThread():
         # Join all threads before exiting
-        print "Cleaning up thread", t
+        print("Cleaning up thread", t)
         t.join()
 sys.exit(result)
Index: core/rosbuild/private.cmake
===================================================================
--- core/rosbuild/private.cmake	(revision 12349)
+++ core/rosbuild/private.cmake	(working copy)
@@ -380,7 +380,7 @@
 
 macro(_rosbuild_get_clock var)
   execute_process(
-    COMMAND python -c "import time; print time.time()"
+    COMMAND python -c "import time; print(time.time())"
     OUTPUT_VARIABLE ${var}
     ERROR_VARIABLE _time_error
     RESULT_VARIABLE _time_failed
@@ -414,7 +414,7 @@
     # Call Python to compare the provided time to the latest mtime on all
     # the files
     execute_process(
-      COMMAND python -c "import os; print 1 if set(${_pylist}) != set(${_cached_pylist}) or ${_t} < max(os.stat(f).st_mtime for f in ${_pylist}) else 0;"
+      COMMAND python -c "import os; print(1 if set(${_pylist}) != set(${_cached_pylist}) or ${_t} < max(os.stat(f).st_mtime for f in ${_pylist}) else 0);"
       OUTPUT_VARIABLE ${var}
       ERROR_VARIABLE _mtime_error
       RESULT_VARIABLE _mtime_failed
Index: core/roslib/src/ros/__init__.py
===================================================================
--- core/roslib/src/ros/__init__.py	(revision 12349)
+++ core/roslib/src/ros/__init__.py	(working copy)
@@ -52,7 +52,7 @@
             import roslib.packages
             try:
                 roslib.load_manifest(name.split('.')[0])
-            except roslib.packages.InvalidROSPkgException, e:
+            except roslib.packages.InvalidROSPkgException as e:
                 raise ImportError("Cannot import module '%s': \n%s"%(name, str(e)))
             return __import__(name)
 
Index: core/roslib/src/roslib/substitution_args.py
===================================================================
--- core/roslib/src/roslib/substitution_args.py	(revision 12349)
+++ core/roslib/src/roslib/substitution_args.py	(working copy)
@@ -38,8 +38,12 @@
 """
 
 import os
-import cStringIO
 
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
 import roslib.exceptions
 import roslib.names
 import roslib.packages
@@ -66,7 +70,7 @@
         raise SubstitutionException("$(env var) command only accepts one argument [%s]"%a)
     try:
         return resolved.replace("$(%s)"%a, os.environ[args[0]])
-    except KeyError, e:
+    except KeyError as e:
         raise SubstitutionException("environment variable %s is not set"%str(e))
 
 def _optenv(resolved, a, args, context):
@@ -224,7 +228,7 @@
     @return: list of arguments
     @rtype: [str]
     """
-    buff = cStringIO.StringIO()
+    buff = StringIO()
     args = []
     state = _OUT
     for c in arg_str:
Index: core/roslib/src/roslib/stacks.py
===================================================================
--- core/roslib/src/roslib/stacks.py	(revision 12349)
+++ core/roslib/src/roslib/stacks.py	(working copy)
@@ -147,8 +147,10 @@
         except KeyError:
             pass
     _update_stack_cache() #update cache
-    val = _dir_cache.get(stack, None)
-    if val is None:
+
+    try:
+        val = _dir_cache[stack]
+    except KeyError:
         raise InvalidROSStackException("Cannot location installation of stack %s. ROS_ROOT[%s] ROS_PACKAGE_PATH[%s]"%(stack, env[ROS_ROOT], env.get(ROS_PACKAGE_PATH, '')))
     return val
 
@@ -179,7 +181,7 @@
     if os.path.exists(os.path.join(ros_root, 'stack.xml')):
         _dir_cache['ros'] = ros_root
         pkg_dirs.remove(ros_root)
-
+    
     # pass in accumulated stacks list to each call. This ensures
     # precedence (i.e. that stacks first on pkg_dirs path win). 
     stacks = []
@@ -198,7 +200,7 @@
     @rtype: [str]
     """
     _update_stack_cache()
-    return _dir_cache.keys()
+    return list(_dir_cache.keys())
 
 def list_stacks_by_path(path, stacks=None, cache=None):
     """
@@ -272,7 +274,7 @@
         if not n in package_list:
             try:
                 valid.extend(roslib.stacks.packages_of(n))
-            except roslib.stacks.InvalidROSStackException, e:
+            except roslib.stacks.InvalidROSStackException as e:
                 invalid.append(n)
         else:
             valid.append(n)
Index: core/roslib/src/roslib/network.py
===================================================================
--- core/roslib/src/roslib/network.py	(revision 12349)
+++ core/roslib/src/roslib/network.py	(working copy)
@@ -45,12 +45,15 @@
 
 import os
 import socket
-import string
 import struct
 import sys
 import platform
-import urlparse
 
+try:
+    import urllib.parse as urlparse
+except ImportError:
+    import urlparse
+
 import roslib.exceptions
 import roslib.rosenv 
 
@@ -97,7 +100,7 @@
         raise ValueError('not a valid URL')
     if ':' in p[1]:
         hostname, port = p[1].split(':')
-        port = string.atoi(port)
+        port = int(port)
     else: 
         hostname, port = p[1], 80
     return hostname, port
@@ -384,7 +387,7 @@
     @return: header encoded as byte string
     @rtype: str
     """    
-    fields = ["%s=%s"%(k,v) for k,v in header.iteritems()]
+    fields = ["%s=%s"%(k,v) for k,v in header.items()]
     s = ''.join(["%s%s"%(struct.pack('<I', len(f)), f) for f in fields])
     return struct.pack('<I', len(s)) + s
                                         
Index: core/roslib/src/roslib/gentools.py
===================================================================
--- core/roslib/src/roslib/gentools.py	(revision 12349)
+++ core/roslib/src/roslib/gentools.py	(working copy)
@@ -44,8 +44,13 @@
 # generator library is rospy.genpy.
 
 import sys
-import cStringIO
 
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
+
 import roslib.msgs 
 import roslib.names 
 import roslib.packages 
@@ -101,7 +106,7 @@
     # #1554: need to suppress computation of files in dynamic generation case
     compute_files = 'files' in get_deps_dict
 
-    buff = cStringIO.StringIO()    
+    buff = StringIO()    
 
     for c in spec.constants:
         buff.write("%s %s=%s\n"%(c.type, c.name, c.val_text))
@@ -218,7 +223,7 @@
     @return: concatenated text for msg/srv file and embedded msg/srv types.
     @rtype:  str
     """
-    buff = cStringIO.StringIO()
+    buff = StringIO()
     sep = '='*80+'\n'
 
     # write the text of the top-level type
Index: core/roslib/src/roslib/stack_manifest.py
===================================================================
--- core/roslib/src/roslib/stack_manifest.py	(revision 12349)
+++ core/roslib/src/roslib/stack_manifest.py	(working copy)
@@ -82,7 +82,7 @@
 Stack '%(stack_dir)s' is improperly configured: no manifest file is present.
 """%locals())
         return p
-    except roslib.stacks.InvalidROSStackException, e:
+    except roslib.stacks.InvalidROSStackException as e:
         if required:
             raise
 
Index: core/roslib/src/roslib/srvs.py
===================================================================
--- core/roslib/src/roslib/srvs.py	(revision 12349)
+++ core/roslib/src/roslib/srvs.py	(working copy)
@@ -39,8 +39,12 @@
 
 import os
 import re
-import cStringIO
 
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
 import roslib.exceptions
 import roslib.msgs
 import roslib.names
@@ -136,9 +140,9 @@
         try: 
             spec = load_from_file(srv_file(package, t), package)
             specs.append(spec)
-        except Exception, e:
+        except Exception as e:
             failures.append(t)
-            print "ERROR: unable to load %s"%t
+            print("ERROR: unable to load %s"%t)
     return specs, failures
 
 ##
@@ -148,8 +152,8 @@
 #  @return roslib.MsgSpec: Message type name and message specification
 #  @throws roslib.MsgSpecException: if syntax errors or other problems are detected in file
 def load_from_string(text, package_context='', full_name='', short_name=''):
-    text_in  = cStringIO.StringIO()
-    text_out = cStringIO.StringIO()
+    text_in  = StringIO()
+    text_out = StringIO()
     accum = text_in
     for l in text.split('\n'):
         l = l.split(COMMENTCHAR)[0].strip() #strip comments        
@@ -172,9 +176,9 @@
 def load_from_file(file, package_context=''):
     if VERBOSE:
         if package_context:
-            print "Load spec from", file, "into namespace [%s]"%package_context
+            print("Load spec from", file, "into namespace [%s]"%package_context)
         else:
-            print "Load spec from", file            
+            print("Load spec from", file)            
     fileName = os.path.basename(file)
     type_ = fileName[:-len(EXT)]
     base_type_ = type_
Index: core/roslib/src/roslib/manifestlib.py
===================================================================
--- core/roslib/src/roslib/manifestlib.py	(revision 12349)
+++ core/roslib/src/roslib/manifestlib.py	(working copy)
@@ -54,10 +54,18 @@
 
 class ManifestException(roslib.exceptions.ROSLibException): pass
 
+def isstring(s):
+    """Small helper version to check an object is a string in a way that works
+    for both Python 2 and 3
+    """
+    try:
+        return isinstance(s, basestring)
+    except NameError:
+        return isinstance(s, str)
+
 # TODO: this is all needlessly complicated in and indirect. Now that
 # we are more commited to our manifest spec, this can be more direct
 # (and unit tested)
-
 def check_optional(name, allowXHTML=False):
     """
     Validator for optional elements.
@@ -81,7 +89,7 @@
     def check(n, filename):
         n = n.getElementsByTagName(name)
         if not n:
-            print >> sys.stderr, "Invalid manifest file[%s]: missing required '%s' element"%(filename, name)
+            sys.stderr.write("Invalid manifest file[%s]: missing required '%s' element\n"%(filename, name))
             return ''
         if len(n) != 1:
             raise ManifestException("Invalid manifest file: must have only one '%s' element"%name)
@@ -99,7 +107,7 @@
         platforms = [e for e in n.getElementsByTagName(name)]
         try:
             vals = [(p.attributes['os'].value, p.attributes['version'].value, p.getAttribute('notes')) for p in platforms]
-        except KeyError, e:
+        except KeyError as e:
             raise ManifestException("<platform> tag is missing required '%s' attribute"%str(e))
         return [Platform(*v) for v in vals]
     return check
@@ -139,7 +147,7 @@
 
 def _attrs(node):
     attrs = {}
-    for k in node.attributes.keys(): 
+    for k in list(node.attributes.keys()): 
         attrs[k] = node.attributes.get(k).value
     return attrs
     
@@ -211,7 +219,7 @@
         @return: export instance represented as manifest XML
         @rtype: str
         """        
-        attrs = ' '.join([' %s="%s"'%(k,v) for k,v in self.attrs.iteritems()])
+        attrs = ' '.join([' %s="%s"'%(k,v) for k,v in self.attrs.items()])
         if self.str:
             return '<%s%s>%s</%s>'%(self.tag, attrs, self.str, self.tag)
         else:
@@ -233,11 +241,11 @@
         @param notes: (optional) notes about platform support
         @type  notes: str
         """
-        if not os or not isinstance(os, basestring):
+        if not os or not isstring(os):
             raise ValueError("bad 'os' attribute")
-        if not version or not isinstance(version, basestring):
+        if not version or not isstring(version):
             raise ValueError("bad 'version' attribute")
-        if notes and not isinstance(notes, basestring):
+        if notes and not isstring(notes):
             raise ValueError("bad 'notes' attribute")            
         self.os = os
         self.version = version
@@ -276,7 +284,7 @@
         @param package: package name. must be non-empty
         @type  package: str
         """
-        if not package or not isinstance(package, basestring):
+        if not package or not isstring(package):
             raise ValueError("bad 'package' attribute")
         self.package = package
     def __str__(self):
@@ -305,7 +313,7 @@
         @param stack: stack name. must be non-empty
         @type  stack: str
         """
-        if not stack or not isinstance(stack, basestring):
+        if not stack or not isstring(stack):
             raise ValueError("bad 'stack' attribute")
         self.stack = stack
         self.annotation = None
@@ -340,7 +348,7 @@
         @param name: dependency name. Must be non-empty.
         @type  name: str
         """
-        if not name or not isinstance(name, basestring):
+        if not name or not isstring(name):
             raise ValueError("bad 'name' attribute")
         self.name = name
     def xml(self):
@@ -363,9 +371,9 @@
         @param url: URL associated with version control. must be non empty
         @type  url: str
         """
-        if not type_ or not isinstance(type_, basestring):
+        if not type_ or not isstring(type_):
             raise ValueError("bad 'type' attribute")
-        if not url is None and not isinstance(url, basestring):
+        if not url is None and not isstring(url):
             raise ValueError("bad 'url' attribute")
         self.type = type_
         self.url = url
@@ -441,7 +449,7 @@
             review = '  <review status="%s" notes="%s" />'%(self.status, self.notes)
 
 
-        fields = filter(lambda x: x, [desc, author, license, review, url, logo, depends, rosdeps, platforms, exports, versioncontrol])
+        fields = [x for x in [desc, author, license, review, url, logo, depends, rosdeps, platforms, exports, versioncontrol] if x]
         return "<%s>\n"%self._type + "\n".join(fields) + "\n</%s>"%self._type
 
 def _get_text(nodes):
@@ -471,7 +479,7 @@
         f.close()
     try:
         return parse(m, text, file)
-    except ManifestException, e:
+    except ManifestException as e:
         raise ManifestException("Invalid manifest file [%s]: %s"%(os.path.abspath(file), e))
 
 def parse(m, string, filename='string'):
@@ -486,7 +494,7 @@
     """
     try:
         d = dom.parseString(string)
-    except Exception, e:
+    except Exception as e:
         raise ManifestException("invalid XML: %s"%e)
     p = d.getElementsByTagName(m._type)
     if len(p) != 1:
Index: core/roslib/src/roslib/msg/_Clock.py
===================================================================
--- core/roslib/src/roslib/msg/_Clock.py	(revision 12349)
+++ core/roslib/src/roslib/msg/_Clock.py	(working copy)
@@ -54,8 +54,8 @@
     try:
       _x = self
       buff.write(_struct_2I.pack(_x.clock.secs, _x.clock.nsecs))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
+    except struct.error as se: self._check_types(se)
+    except TypeError as te: self._check_types(te)
 
   def deserialize(self, str):
     """
@@ -73,7 +73,7 @@
       (_x.clock.secs, _x.clock.nsecs,) = _struct_2I.unpack(str[start:end])
       self.clock.canon()
       return self
-    except struct.error, e:
+    except struct.error as e:
       raise roslib.message.DeserializationError(e) #most likely buffer underfill
 
 
@@ -88,8 +88,8 @@
     try:
       _x = self
       buff.write(_struct_2I.pack(_x.clock.secs, _x.clock.nsecs))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
+    except struct.error as se: self._check_types(se)
+    except TypeError as te: self._check_types(te)
 
   def deserialize_numpy(self, str, numpy):
     """
@@ -109,7 +109,7 @@
       (_x.clock.secs, _x.clock.nsecs,) = _struct_2I.unpack(str[start:end])
       self.clock.canon()
       return self
-    except struct.error, e:
+    except struct.error as e:
       raise roslib.message.DeserializationError(e) #most likely buffer underfill
 
 _struct_I = roslib.message.struct_I
Index: core/roslib/src/roslib/msg/__init__.py
===================================================================
--- core/roslib/src/roslib/msg/__init__.py	(revision 12349)
+++ core/roslib/src/roslib/msg/__init__.py	(working copy)
@@ -1,3 +1,3 @@
-from _Header import *
-from _Log import *
-from _Clock import *
+from ._Header import *
+from ._Log import *
+from ._Clock import *
Index: core/roslib/src/roslib/msg/_Log.py
===================================================================
--- core/roslib/src/roslib/msg/_Log.py	(revision 12349)
+++ core/roslib/src/roslib/msg/_Log.py	(working copy)
@@ -137,8 +137,8 @@
       for val1 in self.topics:
         length = len(val1)
         buff.write(struct.pack('<I%ss'%length, length, val1))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
+    except struct.error as se: self._check_types(se)
+    except TypeError as te: self._check_types(te)
 
   def deserialize(self, str):
     """
@@ -194,7 +194,7 @@
       end += 4
       (length,) = _struct_I.unpack(str[start:end])
       self.topics = []
-      for i in xrange(0, length):
+      for i in range(0, length):
         start = end
         end += 4
         (length,) = _struct_I.unpack(str[start:end])
@@ -203,7 +203,7 @@
         val1 = str[start:end]
         self.topics.append(val1)
       return self
-    except struct.error, e:
+    except struct.error as e:
       raise roslib.message.DeserializationError(e) #most likely buffer underfill
 
 
@@ -240,8 +240,8 @@
       for val1 in self.topics:
         length = len(val1)
         buff.write(struct.pack('<I%ss'%length, length, val1))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
+    except struct.error as se: self._check_types(se)
+    except TypeError as te: self._check_types(te)
 
   def deserialize_numpy(self, str, numpy):
     """
@@ -299,7 +299,7 @@
       end += 4
       (length,) = _struct_I.unpack(str[start:end])
       self.topics = []
-      for i in xrange(0, length):
+      for i in range(0, length):
         start = end
         end += 4
         (length,) = _struct_I.unpack(str[start:end])
@@ -308,7 +308,7 @@
         val1 = str[start:end]
         self.topics.append(val1)
       return self
-    except struct.error, e:
+    except struct.error as e:
       raise roslib.message.DeserializationError(e) #most likely buffer underfill
 
 _struct_I = roslib.message.struct_I
Index: core/roslib/src/roslib/msg/_Header.py
===================================================================
--- core/roslib/src/roslib/msg/_Header.py	(revision 12349)
+++ core/roslib/src/roslib/msg/_Header.py	(working copy)
@@ -74,8 +74,10 @@
       _x = self.frame_id
       length = len(_x)
       buff.write(struct.pack('<I%ss'%length, length, _x))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
+    except struct.error as se:
+        self._check_types(se)
+    except TypeError as te: 
+        self._check_types(te)
 
   def deserialize(self, str):
     """
@@ -99,7 +101,7 @@
       self.frame_id = str[start:end]
       self.stamp.canon()
       return self
-    except struct.error, e:
+    except struct.error as e:
       raise roslib.message.DeserializationError(e) #most likely buffer underfill
 
 
@@ -117,8 +119,10 @@
       _x = self.frame_id
       length = len(_x)
       buff.write(struct.pack('<I%ss'%length, length, _x))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
+    except struct.error as se:
+        self._check_types(se)
+    except TypeError as te:
+        self._check_types(te)
 
   def deserialize_numpy(self, str, numpy):
     """
@@ -144,7 +148,7 @@
       self.frame_id = str[start:end]
       self.stamp.canon()
       return self
-    except struct.error, e:
+    except struct.error as e:
       raise roslib.message.DeserializationError(e) #most likely buffer underfill
 
 _struct_I = roslib.message.struct_I
Index: core/roslib/src/roslib/launcher.py
===================================================================
--- core/roslib/src/roslib/launcher.py	(revision 12349)
+++ core/roslib/src/roslib/launcher.py	(working copy)
@@ -89,7 +89,7 @@
                 paths.append(e.replace('${prefix}', pkg_dir))
     else:
         dirs = [os.path.join(pkg_dir, d) for d in ['src', 'lib']]
-        paths.extend(filter(os.path.isdir, dirs))
+        paths.extend(list(filter(os.path.isdir, dirs)))
     
 def _generate_python_path(pkg, depends, env=os.environ):
     """
@@ -120,7 +120,7 @@
                 continue 
             try: #add sub-dependencies to paths and depends
                 paths.extend(_generate_python_path(d.package, depends, env))
-            except roslib.packages.InvalidROSPkgException, e:
+            except roslib.packages.InvalidROSPkgException as e:
                 # translate error message to give more context
                 raise roslib.packages.InvalidROSPkgException("While loading package '%s': %s"%(d.package, str(e)))
             except:
Index: core/roslib/src/roslib/scriptutil.py
===================================================================
--- core/roslib/src/roslib/scriptutil.py	(revision 12349)
+++ core/roslib/src/roslib/scriptutil.py	(working copy)
@@ -128,14 +128,18 @@
     @return: XML-RPC proxy to ROS master
     @rtype: xmlrpclib.ServerProxy
     """
-    import xmlrpclib
+    try:
+        import xmlrpc.client as xmlrpcclient  #Python 3.x
+    except ImportError:
+        import xmlrpclib as xmlrpcclient #Python 2.x
+    
     # #1730 validate URL for better error messages
     uri = roslib.rosenv.get_master_uri()
     try:
         roslib.network.parse_http_host_and_port(uri)
     except ValueError:
         raise roslib.exceptions.ROSLibException("invalid master URI: %s"%uri)
-    return xmlrpclib.ServerProxy(uri)
+    return xmlrpcclient.ServerProxy(uri)
 
 
 def get_param_server():
@@ -194,7 +198,7 @@
     # Pretty-print a string version of the commands
     def quote(s):
         return '"%s"'%s if ' ' in s else s
-    print "Okay to execute:\n\n%s\n(y/n)?"%('\n'.join([' '.join([quote(s) for s in c]) for c in cmds]))
+    print("Okay to execute:\n\n%s\n(y/n)?"%('\n'.join([' '.join([quote(s) for s in c]) for c in cmds])))
     while 1:
         input = sys.stdin.readline().strip()
         if input in ['y', 'n']:
Index: core/roslib/src/roslib/rospack.py
===================================================================
--- core/roslib/src/roslib/rospack.py	(revision 12349)
+++ core/roslib/src/roslib/rospack.py	(working copy)
@@ -49,7 +49,7 @@
     @raise roslib.exceptions.ROSLibException: if rospack command fails
     """
     rospack_bin = os.path.join(roslib.rosenv.get_ros_root(), 'bin', 'rospack')
-    val = (subprocess.Popen([rospack_bin] + args, stdout=subprocess.PIPE, stderr=subprocess.PIPE).communicate()[0] or '').strip()
+    val = (bytes.decode(subprocess.Popen([rospack_bin] + args, stdout=subprocess.PIPE, stderr=subprocess.PIPE).communicate()[0]) or '').strip()
     if val.startswith('rospack:'): #rospack error message
         raise roslib.exceptions.ROSLibException(val)
     return val
@@ -110,7 +110,7 @@
     @raise roslib.exceptions.ROSLibException: if rosstack command fails
     """
     rosstack_bin = os.path.join(roslib.rosenv.get_ros_root(), 'bin', 'rosstack')
-    val = (subprocess.Popen([rosstack_bin] + args, stdout=subprocess.PIPE, stderr=subprocess.PIPE).communicate()[0] or '').strip()
+    val = (bytes.decode(subprocess.Popen([rosstack_bin] + args, stdout=subprocess.PIPE, stderr=subprocess.PIPE).communicate()[0]) or '').strip()
     if val.startswith('rosstack:'): #rospack error message
         raise roslib.exceptions.ROSLibException(val)
     return val
